
package net.mcreator.iwosmobs.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.HierarchicalModel;

import net.mcreator.iwosmobs.entity.EatingflowerEntity;
import net.mcreator.iwosmobs.client.model.animations.eatingflowerAnimation;
import net.mcreator.iwosmobs.client.model.Modeleatingflower;

public class EatingflowerRenderer extends MobRenderer<EatingflowerEntity, Modeleatingflower<EatingflowerEntity>> {
	public EatingflowerRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(Modeleatingflower.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public ResourceLocation getTextureLocation(EatingflowerEntity entity) {
		return new ResourceLocation("iwos_mobs:textures/entities/textureflawer.png");
	}

	private static final class AnimatedModel extends Modeleatingflower<EatingflowerEntity> {
		private final ModelPart root;
		private final HierarchicalModel animator = new HierarchicalModel<EatingflowerEntity>() {
			@Override
			public ModelPart root() {
				return root;
			}

			@Override
			public void setupAnim(EatingflowerEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
				this.root().getAllParts().forEach(ModelPart::resetPose);
				this.animate(entity.animationState0, eatingflowerAnimation.animationidle, ageInTicks, 1f);
				this.animate(entity.animationState1, eatingflowerAnimation.animationcrawl, ageInTicks, 1f);
				this.animate(entity.animationState2, eatingflowerAnimation.animationattack, ageInTicks, 1f);
			}
		};

		public AnimatedModel(ModelPart root) {
			super(root);
			this.root = root;
		}

		@Override
		public void setupAnim(EatingflowerEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
			animator.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
			super.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
		}
	}
}
