
package net.mcreator.iwosmobs.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.HierarchicalModel;

import net.mcreator.iwosmobs.entity.FlytrapEntity;
import net.mcreator.iwosmobs.client.model.animations.flytrapAnimation;
import net.mcreator.iwosmobs.client.model.Modelflytrap;

public class FlytrapRenderer extends MobRenderer<FlytrapEntity, Modelflytrap<FlytrapEntity>> {
	public FlytrapRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(Modelflytrap.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public ResourceLocation getTextureLocation(FlytrapEntity entity) {
		return new ResourceLocation("iwos_mobs:textures/entities/textureflytrap.png");
	}

	private static final class AnimatedModel extends Modelflytrap<FlytrapEntity> {
		private final ModelPart root;
		private final HierarchicalModel animator = new HierarchicalModel<FlytrapEntity>() {
			@Override
			public ModelPart root() {
				return root;
			}

			@Override
			public void setupAnim(FlytrapEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
				this.root().getAllParts().forEach(ModelPart::resetPose);
				this.animate(entity.animationState0, flytrapAnimation.idle, ageInTicks, 1f);
				this.animateWalk(flytrapAnimation.walk, limbSwing, limbSwingAmount, 1f, 1f);
				this.animate(entity.animationState2, flytrapAnimation.attack, ageInTicks, 1f);
			}
		};

		public AnimatedModel(ModelPart root) {
			super(root);
			this.root = root;
		}

		@Override
		public void setupAnim(FlytrapEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
			animator.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
			super.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
		}
	}
}
