
package net.mcreator.iwosmobs.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.HierarchicalModel;

import net.mcreator.iwosmobs.entity.LivingflowerEntity;
import net.mcreator.iwosmobs.client.model.animations.flowerAnimation;
import net.mcreator.iwosmobs.client.model.Modelflower;

public class LivingflowerRenderer extends MobRenderer<LivingflowerEntity, Modelflower<LivingflowerEntity>> {
	public LivingflowerRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(Modelflower.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public ResourceLocation getTextureLocation(LivingflowerEntity entity) {
		return new ResourceLocation("iwos_mobs:textures/entities/flower.png");
	}

	private static final class AnimatedModel extends Modelflower<LivingflowerEntity> {
		private final ModelPart root;
		private final HierarchicalModel animator = new HierarchicalModel<LivingflowerEntity>() {
			@Override
			public ModelPart root() {
				return root;
			}

			@Override
			public void setupAnim(LivingflowerEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
				this.root().getAllParts().forEach(ModelPart::resetPose);
				this.animate(entity.animationState0, flowerAnimation.animationidle, ageInTicks, 1f);
				this.animateWalk(flowerAnimation.animationwalk, limbSwing, limbSwingAmount, 1f, 1f);
			}
		};

		public AnimatedModel(ModelPart root) {
			super(root);
			this.root = root;
		}

		@Override
		public void setupAnim(LivingflowerEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
			animator.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
			super.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
		}
	}
}
