
package net.mcreator.iwosmobs.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.HierarchicalModel;

import net.mcreator.iwosmobs.entity.QueenbeeEntity;
import net.mcreator.iwosmobs.client.model.animations.queenbeeAnimation;
import net.mcreator.iwosmobs.client.model.Modelqueenbee;

public class QueenbeeRenderer extends MobRenderer<QueenbeeEntity, Modelqueenbee<QueenbeeEntity>> {
	public QueenbeeRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(Modelqueenbee.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public ResourceLocation getTextureLocation(QueenbeeEntity entity) {
		return new ResourceLocation("iwos_mobs:textures/entities/texturebee.png");
	}

	private static final class AnimatedModel extends Modelqueenbee<QueenbeeEntity> {
		private final ModelPart root;
		private final HierarchicalModel animator = new HierarchicalModel<QueenbeeEntity>() {
			@Override
			public ModelPart root() {
				return root;
			}

			@Override
			public void setupAnim(QueenbeeEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
				this.root().getAllParts().forEach(ModelPart::resetPose);
				this.animate(entity.animationState0, queenbeeAnimation.animationidle, ageInTicks, 1f);
				this.animateWalk(queenbeeAnimation.fly, limbSwing, limbSwingAmount, 1f, 1f);
			}
		};

		public AnimatedModel(ModelPart root) {
			super(root);
			this.root = root;
		}

		@Override
		public void setupAnim(QueenbeeEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
			animator.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
			super.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
		}
	}
}
